"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pipe = pipe;

/* Pipes a value through a line of functions.
 * Allows to replace `f3(f2(f1(x)))` with `pipe(x, f1, f2, f3)`
 *
 * Note: It's not well typed with Flow, we had to resort to `any`
 */
function pipe(value) {
  for (var _len = arguments.length, fns = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    fns[_key - 1] = arguments[_key];
  }

  return fns.reduce(function (x, fn) {
    return fn(x);
  }, value);
}